include masm32rt.inc
;#########################################################################
;		RadASM Add In Include

;	include \RadASM\Masm\Inc\radasm.inc
	include	..\..\Inc\RadADDIN.inc
	include \RadASM\Masm\Inc\raEdit.inc
	include \masm32\macros\strings.mac

;#########################################################################
;		VKim's Debug

;	include \RadASM\masm\inc\debug.inc
;	includelib \RadASM\masm\lib\debug.lib


;	include debug.inc
;	includelib debug.lib


	DBGWIN_DEBUG_ON = 1		; include debug info into the program
	DBGWIN_EXT_INFO = 0		; include extra debug info into the program

;#########################################################################
;		Prototypes
include	Proto.inc
include EQUs.inc
ID_EDIT 						= 65501
;
RABRUSH struct
	hBrBck		dd ?			;Back color brush
	hBrSelBck	dd ?			;Sel back color brush
	hBrHilite1	dd ?			;Line hilite 1
	hBrHilite2	dd ?			;Line hilite 2
	hBrHilite3	dd ?			;Line hilite 3
	hBrSelBar	dd ?			;Selection bar
	hPenSelbar	dd ?			;Selection bar pen
RABRUSH ends


RAFONTINFO struct
	charset		dd ?			;Character set
	fDBCS		dd ?			;Use double byte characters
	fntwt		dd ?			;Font width
	fntht		dd ?			;Font height
	spcwt		dd ?			;Space width
	tabwt		dd ?			;Tab width
	italic		dd ?			;Height shift
	monospace	dd ?			;Font is monospaced
	linespace	dd ?			;Extra line spacing
RAFONTINFO ends

RAEDT struct
	hwnd		dd ?			;Handle of edit a or b
	hvscroll	dd ?			;Handle of scroll bar
	cpxmax		dd ?			;Last cursor pos x
	cpy			dd ?			;Scroll position
	cp			dd ?			;Character position
	rc			RECT <?>		;Edit a or b rect
	topyp		dd ?			;First visible lines Y position
	topln		dd ?			;First visible lines linenumber
	topcp		dd ?			;First visible lines character position
RAEDT ends


EDIT struct
	hwnd		dd ?			;Handle of main window
	fstyle		dd ?			;Window style
	ID			dd ?			;Window ID
	hpar		dd ?			;Handle of parent window
	edta		RAEDT <>
	edtb		RAEDT <>
	hhscroll	dd ?			;Handle of horizontal scrollbar
	hgrip		dd ?			;Handle of sizegrip
	hnogrip		dd ?			;Handle of nosizegrip
	hsbtn		dd ?			;Handle of splitt button
	hlin		dd ?			;Handle of linenumber button
	hexp		dd ?			;Handle of expand button
	hcol		dd ?			;Handle of collapse button
	hsta		dd ?			;Handle of state window
	htt			dd ?			;Handle of tooltip
	fresize		dd ?			;Resize in action flag
	fsplitt		dd ?			;Splitt factor
	nsplitt		dd ?			;Splitt height

	hHeap		dd 3 dup(?)		;Handle of heap
	hLine		dd ?			;Handle of line pointer mem
	cbLine		dd ?			;Size of line pointer mem
	rpLine		dd ?			;Relative pointer into line pointer mem
	rpLineFree	dd ?			;Pointer to free line pointer
	hChars		dd ?			;Handle of character mem
	cbChars		dd ?			;Size of character mem
	rpChars		dd ?			;Relative pointer into character mem
	rpCharsFree	dd ?			;Relative pointer to free character
	hUndo		dd ?			;Handle of undo memory
	cbUndo		dd ?			;Size of undo memory
	rpUndo		dd ?			;Relative pointer to free (last)
	line		dd ?			;Linenumber
	cpLine		dd ?			;Character position for start of line

	rc			RECT <?>		;Main rect
	selbarwt	dd ?			;Width of selection bar
	nlinenrwt	dd ?			;Initial width of linenumber bar
	linenrwt	dd ?			;Width of linenumber bar
	nScroll		dd ?			;Mouse wheel scroll lines
	nPageBreak	dd ?			;Page break
	cpMin		dd ?			;Selection min
	cpMax		dd ?			;Selection max
	fOvr		dd ?			;Insert / Overwrite
	nHidden		dd ?			;Number of hidden lines
	cpx			dd ?			;Scroll position
	focus		dd ?			;Handle of edit having focus
	fCaretHide	dd ?			;Caret is hidden
	fChanged	dd ?			;Content changed
	fHideSel	dd ?			;Hide selection
	fIndent		dd ?			;Auto indent
	clr			RACOLOR <?>
	br			RABRUSH <?>
	nTab		dd ?			;Tab size
	fnt			RAFONT <?>
	fntinfo		RAFONTINFO <?>
	lpBmCB		dd ?			;Bookmark paint callback
	nchange		dd ?			;Used by EN_SELCHANGE
	nlastchange	dd ?			;Used by EN_SELCHANGE
	nWordGroup	dd ?			;Hilite word group
	fExpandTab	dd ?			;TRUE/FALSE Epand tabs to spaces
	savesel		CHARRANGE <?>
	htlt		dd ?			;Scroll tooltip
	nMode		dd ?			;Block selection
	blrg		BLOCKRANGE <?>
	lockundoid	dd ?
	ccmntblocks	dd ?
EDIT ends


HLLIDACOLOR struct
	WordText		dd ?
	WordBack		dd ?
	StringText	dd ?
	StringBack	dd ?
	CaseText		dd ?
	CaseBack		dd ?
	SelectText	dd ?
	SelectBack	dd ?
HLLIDACOLOR ends



.LIST
.data
vSBA			dd 8 DUP(0)
szOpt1	db 'Enable',0
O_EN	equ 00000001b
;										AND		OR
AddinOpt	ADDINOPT <offset szOpt1,O_EN,O_EN>
			ADDINOPT <0,0,0>
.NOLIST


.data?
hInstance					DD ?	;Dll's module handle
lpHandles					DD ?	;Pointer to handles struct
lpProc						DD ?	;Pointer to proc struct
lpData						DD ?	;Pointer to data struct
hOut							DD ?	;Handle of output window
IDAddIn						DD ?	;Unique ID for this AddIn


hEdt1							DD ?
OldEditProc1			DD ?
hEdt2							DD ?
OldEditProc2			DD ?

;RichEditVersion	DD ?

szHL							DB	128 dup(?)
sizeHL						DD ?
flgHL							DD ?
lpEDIT_struct			DD ?

;hStatB						DD ?
fOptions					DD ?
vBeginSel					DD ?



szOrigin					DB	64 dup(?)


buffer						DB 1024*10 DUP(?)

hBrushWordText 		DD ?
hBrushWordBack 		DD ?
hBrushStringText 	DD ?
hBrushStringBack 	DD ?
hBrushCaseText 		DD ?
hBrushCaseBack 		DD ?
hBrushSelectText 	DD ?
hBrushSelectBack 	DD ?

HL_Colors					HLLIDACOLOR<>
tHL_Colors 				HLLIDACOLOR<>
CustColor 				DD 16 DUP(?)

.code


